<template>
  <div>
    <LineChart ref="chart" :chartData="chartData" :options="chartOptions" />
  </div>
</template>

<script>
import 'chartjs-adapter-moment'
import LineChart from './LineChart'

function color (name) {
  const style = getComputedStyle(document.body)
  return style.getPropertyValue(name)
}

const chartLook = {
  backgroundColor: color('--color-primary'),
  borderColor: color('--color-primary'),
  fill: false
}

export default {
  components: {
    LineChart
  },
  props: {
    resultsData: Object
  },
  computed: {
    chartData () {
      return {
        datasets:
          this.resultsData.before !== undefined
            ? [
                {
                  ...chartLook,
                  label: this.$t('data.beforeChangepoint', {
                    site: this.resultsData.label
                  }),
                  data: this.resultsData.before.map((d) => ({
                    x: d.date,
                    y: d.usage
                  }))
                },
                {
                  ...chartLook,
                  backgroundColor: color('--color-secondary'),
                  borderColor: color('--color-secondary'),
                  label: this.$t('data.afterChangepoint', {
                    site: this.resultsData.label
                  }),
                  data: this.resultsData.after.map((d) => ({
                    x: d.date,
                    y: d.usage
                  }))
                }
              ]
            : [
                {
                  ...chartLook,
                  label: this.resultsData.label,
                  data: this.resultsData.data.map((d) => ({
                    x: d.date,
                    y: d.usage
                  }))
                }
              ]
      }
    },
    chartOptions () {
      // chart.js is bad and doesn't let us translate stuff in a reasonable way so we just have everything in the default english instead
      // we could maybe switch to one of the other adapters (that isn't moment.js) to get some localization options
      // https://www.chartjs.org/docs/latest/axes/cartesian/time.html

      return {
        responsive: true,
        maintainAspectRatio: false,
        tension: 0.4,
        onResize: this.setHeight,
        plugins: {
          legend: {
            display: false
          },
        },
        scales: {
          x: {
            type: 'time',
            border: {
              dash: [4, 4]
            },
            grid: {
              color: color('--color-dividers')
            }
          },
          y: {
            beginAtZero: true
          }
        }
      }
    }
  },
  methods: {
    downloadImage () {
      this.$refs.chart.downloadImage()
    },
    setHeight () {
      this.$refs.chart.$el.style.height = '400px'
    }
  },
}
</script>

<style scoped lang="scss"></style>
